本项目在rCore-Tutorial-v3的基础上添加了中断



## K210 的设备缺陷

由于k210并实现S态外设中断， 因此使用软中断来模拟外设中断。



## 处理步骤

由于k210没有S态外设中断，于是只能通过M态也就是SBI来接收态中断，SBI接收外设中断后，清楚M态定时器中断，外设中断，设置ssip。在M态处理完之后，S态也就是OS会接收到软中断，S态处理完之后，再进入M态开启M态外设中断，定时器中断。 就这样M态外设中断就能“代理”到S态软中断处理。 这样的方式对于S态来说是透明的，S态只需将软中断当作外设中断处理即可。

#### 不足：

​	占用了S态软中断，导致其他基于软中断的逻辑代码难以开发



#### 基于中断处理流程：

<img src="asserts\中断.png" alt="中断" style="zoom:80%;" />







#### 基于进程的视角：

<img src="C:\Users\14861\Desktop\oskernel2022-lotusos\docs\asserts\处理流程.png" alt="处理流程" style="zoom:80%;" />



#### 特殊设置：

​	由于在init进程初始化前，由于无法调度到其他进程，启动中断式的模型无异于轮询，反而增加了设计难度。所以 在初始化init进程之前，都是通过轮询来读取外设，在初始完成init进程之后，才开始采用中断的方式来请求外设。



#### 中断的开启与关闭





#### SD卡中断驱动

​	在k210中，如需使用中断，则应当使用dma来读取SD卡。需要将原来的spi驱动，改成dma驱动，大致可以参照官方的sdk。

​	需要注意的是在 **CHn_CFG** 寄存器中有 **TT_FC** （34：32）位，在驱动中会基于源地址和目的地址来设置DMA的来源和目的地。一共有如下6中模式：

- 0x2 (PER_TO_MEM_DMAC)
- 0x3 (PER_TO_PER_DMAC)
- 0x4 (PER_TO_MEM_SRC)
- 0x5 (PER_TO_PER_SRC)
- 0x6 (MEM_TO_PER_DST)
- 0x7 (PER_TO_PER_DST)



```c
static int is_memory(uintptr_t address)
{
    enum {
        mem_len = 6 * 1024 * 1024,
        mem_no_cache_len = 8 * 1024 * 1024,
    };
    return
    ((address >= 0x80000000) && (address < 0x80000000 + mem_len)) || 
    ((address >= 0x40000000) && (address < 0x40000000 + mem_no_cache_len)) || 
    (address == 0x50450040);
}
```

在官方提供的驱动中0x80000000 - 0x80600000 以及 0x40000000 - 0x40800000 会被判定位memory，因此尽量把不要使用非直接映射的虚拟地址来当做源地址或目的地址，这样会被判定位非memory进而错误的设置**TT_FC** 位