mod k210_plic;
mod qemu_plic;
use alloc::sync::Arc;
use k210_pac::{Interrupt, Peripherals, PLIC};
use k210_soc::plic::{clear_irq, current_irq};

use crate::sync::UPSafeCell;

use super::PlicDevice;

#[cfg(feature = "board_k210")]
type PlicDeviceImpl = k210_plic::Plic;

#[cfg(feature = "board_qemu")]
type PlicDeviceImpl = qemu_plic::Plic;

lazy_static::lazy_static!(
    pub static ref PLIC_DRIVE: Arc<dyn PlicDevice> = Arc::new(PlicDeviceImpl::new());
);
