use crate::trap::trap_return;

#[repr(C)]
pub struct TaskContext {
    ra: usize,
    sp: usize,
    s: [usize; 12],
}

impl TaskContext {
    pub fn zero_init() -> Self {
        Self {
            ra: 0,
            sp: 0,
            s: [0; 12],
        }
    }

    pub fn goto_trap_return(kstack_ptr: usize) -> Self {
        Self {
            ra: trap_return as usize,
            sp: kstack_ptr,
            s: [0; 12],
        }
    }
}

pub struct Pthread {
    _self: usize,
    dtv: usize,
    prev: usize,
    next: usize,
    sysinfo: usize,
    canary: usize,
    tid: i32,
    pub errno_val: i32,
    detach_state: i32,
    cancel: i32,
    canceldisable: u8,
    cancelasync: u8,
    tsd_used: u8,
}
